<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../../../">
  <title data-ice="title">public/js/catalouge/Catalog_Entry/Catalog_Entry_Base.js | archive-system-front-end</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
</head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/ArchiveSys/Web-Catalogue/archive-system-front-end.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js">js</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/moodral.js~moodral.html">moodral</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CONFIG">CONFIG</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge">js/catalouge</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_System.js~Catalog_System.html">Catalog_System</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_System_Base.js~Catalog_System_Base.html">Catalog_System_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-archive-connection">js/catalouge/Archive_Connection</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Archive_Connection/Archive_Connection.js~Archive_Connection.html">Archive_Connection</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-catalog-entry">js/catalouge/Catalog_Entry</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry/Catalog_Entry.js~Catalog_Entry.html">Catalog_Entry</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry/Catalog_Entry_Base.js~Catalog_Entry_Base.html">Catalog_Entry_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-catalog-entry-moodral">js/catalouge/Catalog_Entry_Moodral</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry_Moodral/Catalog_Entry_Moodral.js~Catalog_Entry_Moodral.html">Catalog_Entry_Moodral</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-filter">js/catalouge/Filter</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Filter/Filter.js~Filter.html">Filter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Filter/Filter_Base.js~Filter_Base.html">Filter_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-page-headers">js/catalouge/Page_Headers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Page_Headers/Page_Headers.js~Page_Headers.html">Page_Headers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-toolkit">js/toolkit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/baseToolkit.js~toolkit.html">toolkit</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~baseStorageToolkitExtention.html">baseStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~permanentStorageToolkitExtention.html">permanentStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~sessionStorageToolkitExtention.html">sessionStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/contentToolkitExtention.js~contentToolkitExtention.html">contentToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/endlessScrollToolkitExtention.js~endlessScrollToolkitExtention.html">endlessScrollToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/eventToolkitExtention.js~eventToolkitExtention.html">eventToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/formToolkitExtention.js~formToolkitExtention.html">formToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/httpConnectionsToolkitExtention.js~httpConnectionsToolkitExtention.html">httpConnectionsToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/styleToolkitExtention.js~styleToolkitExtention.html">styleToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/urlToolkitExtention.js~urlToolkitExtention.html">urlToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-aggregator">aggregator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-NOTHING">NOTHING</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">public/js/catalouge/Catalog_Entry/Catalog_Entry_Base.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">/**
 * This is the base Catalouge Entry object.
 * It handles prosessing all the data from the raw data and has a few other helper functions.
 */
export class Catalog_Entry_Base {
  /**
   * The constructor for the Catalog Entry Base.
   * It sets all the local attributes.
   * @public
   * @param {Object} entryData - Entry Data object containing the property&apos;s of the entry.
   * @param {Object} catalogObject - The parrent catalog.
   */
  constructor(entryData, catalogObject){

    /**
     * A Constant representing a empty value.
     * Wouldn&apos;t it be nice if null !== false?
     * The random characters are to try and ensure it&apos;s never equated accedentally.
     * @public
     * @const
     * @example
     * this.sourceURL === this.EMPTY //;
     * = true // the item was empty;
     * = false // the item has data;
     */
    this.EMPTY = &quot;#$%$# MISSING DATA *&amp;%^%&amp;*&quot;;

    /**
     * Contains CSS Selectors for vairious parts of the code.
     * Overridden with child classes
     * @protected
     * @type {Enum&lt;String&gt;}
     * @abstract
     */
    this.css_selectors = {};

    /**
     * The parrent catalouge object.
     * @public
     * @type {Object}
     */
    this.catalog = catalogObject;

    this.__parseEntry(entryData);

  }

  /**
   * Calls other parsers to parse the data.
   * Parses the raw entry and saves the data in pre-specified locations.
   * @private
   * @param {Object} RawData - The raw data that is being inputed.
   */
  __parseEntry( RawData ) {
    this.__parseEntryAlways(RawData);
    this.__parseEntrySometimes(RawData);
  }

  /**
   * Parser for values that should always exsist.
   * Parses the raw entry and saves the data in pre-specified locations.
   * @private
   * @param {Object} RawData - The raw data that is being inputed.
   */
  __parseEntryAlways( RawData ) {
    /**
     * The entry&apos;s catalouge ID.
     * @public
     * @type {number}
     */
    this.id = RawData[&quot;IDC&quot;];

    /**
     * The title of the entry.
     * @public
     * @type {string}
     */
    this.title = RawData[&quot;Title&quot;];

    /**
     * The author of the entry.
     * @public
     * @type {{id: number, name:string}}
     */
    this.author = {
      &quot;id&quot;: RawData[&quot;AuthorID&quot;],
      &quot;name&quot;: RawData[&quot;Author&quot;]
    };

    /**
     * The publisher of the entry. (Where we got the file from.)
     * @public
     * @type {string}
     */
    this.publisher = RawData[&quot;Publisher&quot;];

    /**
     * The blurb / summary for the entry.
     * @public
     * @type {string|DOMString}
     */
    this.blurb = RawData[&quot;Summary&quot;];

    /**
     * The catagory for the entry.
     * @public
     * @type {string}
     */
    this.catagories = RawData[&quot;Catagory&quot;];

    /**
     * The rating of the entry.
     * @public
     * @type {{short:string, long:string}}
     */
    this.rating = {
      &quot;short&quot;: RawData[&quot;Rating&quot;],
      &quot;long&quot;: RawData[&quot;RaitingDef&quot;]
    };

    /**
     * The status of the entry.
     * @public
     * @todo figure out what type this should be.
     */
    this.status = RawData[&quot;Complete&quot;];

  }

  /**
   * Parser for values that sometimes exsist.
   * Parses the raw entry and saves the data in pre-specified locations.
   * @private
   * @param {Object} RawData - The raw data that is being inputed.
   */
  __parseEntrySometimes( RawData ) {
    /**
     * The dates related to the entry.
     * @public
     * @type {{Published:date, Added:date|EMPTY, Downloaded:date|EMPTY, Checked:date|EMPTY, Updated:date|EMPTY}}
     */
    this.dates = {
      &quot;Published&quot;: this.__hasData(RawData[&quot;Published&quot;]),
      &quot;Added&quot;: this.__hasData(RawData[&quot;Downloaded&quot;]),
      &quot;Downloaded&quot;: this.__hasData(RawData[&quot;Downloaded&quot;]),
      &quot;Checked&quot;: this.__hasData(RawData[&quot;Loaded&quot;]),
      &quot;Updated&quot;: this.__hasData(RawData[&quot;Updated&quot;])
    };

    /**
     * The count of varius stuff.
     * Chapters, Words, Minutes, Pages, Etc.
     * @public
     * @type {{chapters:number|EMPTY, words:number|EMPTY}}
     */
    this.count = {
      &quot;chapters&quot;: this.__hasData(RawData[&quot;ChapterCount&quot;]),
      &quot;words&quot;: this.__hasData(RawData[&quot;WordCount&quot;])
    };
    // REVIEW: This is not currently used.
    //         Should be saved on a moodral instead of on the main list.
    /**
     * @TODO Write details on this when it&apos;s implemented.
     *
     */
    this.times = {
      &quot;LastCheck&quot;: this.__hasData(RawData[&quot;LoadedInt&quot;]),
      &quot;NextUpdate&quot;: this.__hasData(RawData[&quot;TimeToUpdate&quot;])
    };

    // TEMP: Keywords should be phased out and replaced with collections &amp; series tags.
    /**
     * Keywords related to the entry
     * @public
     * @type {string|EMPTY}
     * @todo This will be phased out in favor of collections, series&apos;s and tags.
     */
    this.keywords = this.__hasData(RawData[&quot;KeyWords&quot;]);

    /**
     * If the entry is normally hidden.
     * @public
     * @type {boolean|EMPTY}
     */
    this.hidden = this.__hasData(RawData[&quot;LockedCombined&quot;]);

    /**
     * Genres of the entry.
     * @public
     * @type {string|EMPTY}
     */
    this.genres = this.__hasData(RawData[&quot;genres&quot;]);

    /**
     * The Source URL for the entry.
     * @public
     * @type {string|EMPTY}
     */
    this.sourceURL = this.__hasData(RawData[&quot;URL&quot;]);

    /**
     * Major Characters in the entry.
     * @public
     * @type {string|EMPTY}
     */
    this.characters = this.__hasData(RawData[&quot;characters&quot;]);

    /**
     * Character Pairings in the entry.
     * @public
     * @type {string|EMPTY}
     */
    this.pairings = this.__hasData(RawData[&quot;pairings&quot;]);

  }

  /**
   * Checks if input actually has data.
   *
   * Checks if data has data, if not, returns the const EMPTY.
   * @private
   * @param {*} data - The stuff we are checking.
   * @param {boolean} legacy - Legacy option that fixes some bad data.
   * @todo remove legacy option.
   * @return {*|EMPTY} if data is empty, returns EMPTY Const, otherwise returns inputed data.
   *
   */
  __hasData(data, legacy){
    // OPTIMIZE: Figure out what the spread on this is and make it a tree of if statements.
    //           If done right every empty item should be sent as a undefined,
    //           allowing us to skip all other checks.
    legacy = legacy || false;
    switch (data) {
      case &quot;&quot;:
      case null:
      case undefined:
        return this.EMPTY;
        break;
      case 0:
      case &quot;0&quot;:
        // TEMP: Remove legacy stuff when it is phased out.
        if(legacy){
          return this.EMPTY;
          break;
        }
      default:
        return data;
    }
  }



  /**
   * The code that is triggered when the author name is clicked.
   * @private
   */
  __transferAuthorToSearch(){
    this.catalog.filter.setAuthorID(this.author.id);
    this.catalog.filter.onFilterSubmit();
  }

  /**
   * Converts a unix time duration to text for days, hours, minutes, seconds.
   * @public
   * @param {number} timeDuration - the time duration to prosess.
   * @return {String}
   */
  unixToReadable(timeDuration) {
    let s = &quot;&quot;;
    if (timeDuration &lt; 0) {
      s += &quot;Negative &quot;;
      timeDuration = Math.abs(timeDuration);
    }
    let numDays = Math.floor(timeDuration / 86400);
    if(numDays &gt; 0){
      s += (numDays + &quot; days &quot;);
    }
    let numHours = Math.floor((timeDuration % 86400) / 3600);
    if(numHours &gt; 0){
      s += (numHours + &quot; hours &quot;);
    }
    let numMinutes = Math.floor(((timeDuration % 86400) % 3600) / 60);
    if(numMinutes &gt; 0){
      s += (numMinutes + &quot; minutes &quot;);
    }
    let numSeconds = Math.round(((timeDuration % 86400) % 3600) % 60);
    if(numSeconds &gt; 0){
      s += (numSeconds + &quot; seconds&quot;);
    }
    return s;
  }

  /**
   * Removes trailing sets of zero&apos;s from date-times.
   *
   * 2018-10-28 19:55:36 -&gt; 2018-10-28 19:55:36
   * 2018-10-28 19:55:00 -&gt; 2018-10-28 19:55
   * 2018-10-28 00:00:00 -&gt; 2018-10-28
   * @public
   * @param {dateTime|String} dateTime - The date-time to prosess.
   * @returns {String}
   */
  truncateZeroDateTimes(dateTime) {
    return dateTime.toString().replace(/(\s{0,1}:{0,1}00){1,3}/g, &quot;&quot;);
  }

  /**
   * Adds commas to numbers in the thousands, millions, etc places.
   * @public
   * @param {number|String} number - The number to add the commas to.
   * @return {String}
   */
  addCommas(number) {
    return number.toString().replace(/\B(?=(\d{3})+(?!\d))/g, &quot;,&quot;);
  }
}
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
